SELECT DISTINCT tx_org_job.uid AS 'tx_org_job.uid', ACOS
(
    SIN( RADIANS( tx_radialsearch_postalcodes.latitude  ) ) * SIN( RADIANS( tx_org_job.mail_lat ) )
  + COS( RADIANS( tx_radialsearch_postalcodes.latitude  ) ) * COS( RADIANS( tx_org_job.mail_lat ) )
  * COS( RADIANS( tx_radialsearch_postalcodes.longitude )   - RADIANS( tx_org_job.mail_lon ) )
)
* 6378.2 AS 'distance'
 FROM tx_org_job
                LEFT JOIN tx_org_mm_all AS tx_org_job_mm_tx_org_jobcat
                ON
                (
                  tx_org_job.uid = tx_org_job_mm_tx_org_jobcat.uid_local
                  AND tx_org_job_mm_tx_org_jobcat.table_local = 'tx_org_job' AND tx_org_job_mm_tx_org_jobcat.table_foreign = 'tx_org_jobcat'
                )
                LEFT JOIN tx_org_jobcat
                ON
                (
                  tx_org_job_mm_tx_org_jobcat.uid_foreign = tx_org_jobcat.uid
                   AND tx_org_jobcat.deleted=0 AND tx_org_jobcat.hidden=0
                   AND tx_org_jobcat.pid IN (3,4,5,6,7,8,9,10,11,2)
                )
                LEFT JOIN tx_org_mm_all AS tx_org_job_mm_tx_org_jobsector
                ON
                (
                  tx_org_job.uid = tx_org_job_mm_tx_org_jobsector.uid_local
                  AND tx_org_job_mm_tx_org_jobsector.table_local = 'tx_org_job' AND tx_org_job_mm_tx_org_jobsector.table_foreign = 'tx_org_jobsector'
                )
                LEFT JOIN tx_org_jobsector
                ON
                (
                  tx_org_job_mm_tx_org_jobsector.uid_foreign = tx_org_jobsector.uid
                   AND tx_org_jobsector.deleted=0 AND tx_org_jobsector.hidden=0
                   AND tx_org_jobsector.pid IN (3,4,5,6,7,8,9,10,11,2)
                )
                LEFT JOIN tx_org_mm_all AS tx_org_job_mm_tx_org_jobworkinghours
                ON
                (
                  tx_org_job.uid = tx_org_job_mm_tx_org_jobworkinghours.uid_local
                  AND tx_org_job_mm_tx_org_jobworkinghours.table_local = 'tx_org_job' AND tx_org_job_mm_tx_org_jobworkinghours.table_foreign = 'tx_org_jobworkinghours'
                )
                LEFT JOIN tx_org_jobworkinghours
                ON
                (
                  tx_org_job_mm_tx_org_jobworkinghours.uid_foreign = tx_org_jobworkinghours.uid
                   AND tx_org_jobworkinghours.deleted=0 AND tx_org_jobworkinghours.hidden=0
                   AND tx_org_jobworkinghours.pid IN (3,4,5,6,7,8,9,10,11,2)
                )
                LEFT JOIN tx_org_mm_all AS tx_org_headquarters_mm_tx_org_job
                ON
                (
                  tx_org_job.uid = tx_org_headquarters_mm_tx_org_job.uid_foreign
                  AND tx_org_headquarters_mm_tx_org_job.table_local = 'tx_org_headquarters' AND tx_org_headquarters_mm_tx_org_job.table_foreign = 'tx_org_job'
                )
                LEFT JOIN tx_org_headquarters
                ON
                (
                  tx_org_headquarters_mm_tx_org_job.uid_local = tx_org_headquarters.uid
                   AND tx_org_headquarters.deleted=0 AND tx_org_headquarters.hidden=0 AND (tx_org_headquarters.fe_group='' OR tx_org_headquarters.fe_group IS NULL OR tx_org_headquarters.fe_group='0' OR FIND_IN_SET('0',tx_org_headquarters.fe_group) OR FIND_IN_SET('-1',tx_org_headquarters.fe_group))
                   AND tx_org_headquarters.pid IN (3,4,5,6,7,8,9,10,11,2)
                ) CROSS JOIN  tx_radialsearch_postalcodes  WHERE tx_org_job.deleted=0 AND tx_org_job.hidden=0 AND tx_org_job.starttime<=1427492820 AND (tx_org_job.endtime=0 OR tx_org_job.endtime>1427492820) AND tx_org_job.pid IN (3,4,5,6,7,8,9,10,11,2) AND tx_org_job.sys_language_uid <= 0 AND tx_radialsearch_postalcodes.pid = 0

AND
(
      tx_radialsearch_postalcodes.postal_code LIKE "Mannheim%"
  OR  tx_radialsearch_postalcodes.place_name LIKE "Mannheim%"
  OR  CONCAT(tx_radialsearch_postalcodes.postal_code, " ", tx_radialsearch_postalcodes.place_name) LIKE "Mannheim%"
)
 AND tx_radialsearch_postalcodes.deleted=0

 AND (tx_org_job.mail_lat != 0 OR tx_org_job.mail_lon != 0)
GROUP BY tx_org_job.uid
#HAVING distance < 1000
ORDER BY distance ,tx_org_job.title, tx_org_job.mail_city, tx_org_job.mail_zip, tx_org_jobcat.title, tx_org_jobsector.title, tx_org_headquarters.title LIMIT 0,20
