SELECT      DISTINCT tx_org_job.uid AS 'tx_org_job.uid',
            ACOS
            (
                SIN( RADIANS( tx_radialsearch_postalcodes.latitude  ) ) * SIN( RADIANS( tx_org_job.mail_lat ) )
              + COS( RADIANS( tx_radialsearch_postalcodes.latitude  ) ) * COS( RADIANS( tx_org_job.mail_lat ) )
              * COS( RADIANS( tx_radialsearch_postalcodes.longitude )   - RADIANS( tx_org_job.mail_lon ) )
            )
            * 6378.2 AS 'distance'
FROM        tx_org_job
CROSS JOIN  tx_radialsearch_postalcodes
WHERE       (
                  tx_radialsearch_postalcodes.postal_code LIKE "Mannheim%"
              OR  tx_radialsearch_postalcodes.place_name LIKE "Mannheim%"
              OR  CONCAT(tx_radialsearch_postalcodes.postal_code, " ", tx_radialsearch_postalcodes.place_name) LIKE "Mannheim%"
            )
            AND tx_radialsearch_postalcodes.deleted=0
            AND (tx_org_job.mail_lat != 0 OR tx_org_job.mail_lon != 0)
GROUP BY    tx_org_job.uid
ORDER BY    distance
LIMIT       0,20
