/*<![CDATA[*/
/*leafletFooterInline*/


/*
 *   @description Powered by the Leaflet modul of the TYPO3 Browser - TYPO3 without PHP. See http://typo3-browser.de/
 *                Ready to use by the TYPO3 Organsier - TYPO3 for Lobbies and Organisers. See http://typo3-organiser.de/
 *   @author      (c) 2015 - Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 *   @version     7.0.0
 *   @since       7.0.0
 */


var map = L.map( 'leafletmap' );
var googleHybrid = new L.Google( 'HYBRID' );
var googleRoadmap = new L.Google( 'ROADMAP' );
var googleSatellite = new L.Google( 'SATELLITE' );
var googleTerrain = new L.Google( 'TERRAIN' );

var osmRoadmap = L.tileLayer( 'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
  attribution: '&copy; <a href="http://openstreetmap.org" title="openstreetmap.org" style="font-weight:normal" >OpenStreetMap</a>',
  maxZoom: 18
} );

map.setView( [ 43.36615885, -33.137330825 ], 2 );
map.attributionControl.setPrefix( '<a href="http://typo3-organiser.de/" title="TYPO3 Organiser: Leaflet ready to use." style="font-weight:normal">Leaflet/TYPO3</a>' );
map.addLayer( osmRoadmap);
var lg10 = new L.LayerGroup(); // Gesellschaft
var lg20 = new L.LayerGroup(); // TYPO3
L.marker([38.897594, -77.036572]).bindPopup('<div style="float:left;padding:0 1em 1em 0;"><a href="http://www.whitehouse.gov/eastereggroll" title="White House: Ostereier-Party" target="_blank" class="external"><img src="typo3temp/_processed_/csm_tx_org_cal_300x200_2540cb9334.png" width="40" height="40"   alt=""  ></a></div><div class="mapPopupHeader mapPopupHeaderUrl"><a href="http://www.whitehouse.gov/eastereggroll" title="White House: Ostereier-Party" target="_blank" class="external">White House: Ostereier-Party</a></div><div class="mapPopupText mapPopupTextDefault">Der Präsident und die First Lady haben heute...</div>').addTo( lg10),
L.marker([47.1771473, 8.1043593]).bindPopup('<div style="float:left;padding:0 1em 1em 0;"><a href="index.php?id=24&amp;tx_browser_pi1%5BcalendarUid%5D=2&amp;cHash=ee530789446739fdf67194d5b249b768" title="TYPO3 Developer Days" class="linktosingle"><img src="typo3temp/_processed_/csm_t3dd11_header_front_1422979989_684be7e734.jpg" width="40" height="40"   alt=""  ></a></div><div class="mapPopupHeader mapPopupHeaderDefault"><a href="index.php?id=24&amp;tx_browser_pi1%5BcalendarUid%5D=2&amp;cHash=ee530789446739fdf67194d5b249b768" title="TYPO3 Developer Days" class="linktosingle">TYPO3 Developer Days</a></div><div class="mapPopupText mapPopupTextDefault">
Wir laden Dich zu den kommenden TYPO3 Developer Days...</div>').addTo( lg20),
L.marker([48.4923001, 13.4194614]).bindPopup('<div style="float:left;padding:0 1em 1em 0;"><a href="index.php?id=24&amp;tx_browser_pi1%5BcalendarUid%5D=3&amp;cHash=e711a8fdf34336c8607f645465f71e7f" title="Premiere: TYPO3 Organiser" class="linktosingle"><img src="typo3temp/_processed_/csm_ext_icon_org_210px_1422979989_5a39436f93.png" width="40" height="40"   alt=""  ></a></div><div class="mapPopupHeader mapPopupHeaderDefault"><a href="index.php?id=24&amp;tx_browser_pi1%5BcalendarUid%5D=3&amp;cHash=e711a8fdf34336c8607f645465f71e7f" title="Premiere: TYPO3 Organiser" class="linktosingle">Premiere: TYPO3 Organiser</a></div><div class="mapPopupText mapPopupTextDefault">Thema


    Premiere: Organiser - TYPO3 für Lobby und...</div>').addTo( lg20);
map.addLayer( lg10 ); // Gesellschaft
map.addLayer( lg20 ); // TYPO3
var baseLayers = {'Open Street Map' : osmRoadmap, 'Google Maps' : googleRoadmap, 'Satellit' : googleSatellite, 'Satellit/Stra&szlig;e' : googleHybrid, 'Gel&auml;nde' : googleTerrain};
var overlays = { 'Gesellschaft' : lg10, 'TYPO3' : lg20 };
map.addControl( new L.Control.Layers( baseLayers, overlays ));


/*]]>*/
